: drop ] drop ; 
: dup ] dup ; 

: ( $ 0029 l ] word ] drop ; 
: [ ; 

: var c : [ ' lit l ] ,xt ] here ] i, ] ; [ $ 1 l ] cells ] allot ; 
: dvar c : [ ' lit l ] ,xt ] here ] i, ] ; [ $ 2 l ] cells ] allot ; 

macro : invert [ $ 9580 l ] i, [ $ 9590 l ] i, ; 

: 0= if [ $ 0000 l ; then [ $ ffff l ; 
: = ] xor ] 0= ; 

: cell+ [ $ 2 l ] + ; 

( double operators ) 
: d@ ] dup ] cell+ ] @ ] swap ] @ ; 
: d! ] swap ] over ] ! ] cell+ ] ! ; 
: d1- ] swap ] dup if ] 1- ] swap ; then ] 1- ] swap ] 1- ; 
: d1+ ] swap ] 1+ ] dup if ] swap ; then ] swap ] 1+ ; 
: d0= ] 0= if ] 0= if [ $ ffff l ; then then [ $ 0000 l ; 

( interrupts ) 
macro : inton [ $ 9478 l ] i, ; 
macro : intoff [ $ 94f8 l ] i, ; 

( rtos ) 
: hot $ 8000 l ; 
: timed $ 4000 l ; 

dvar clock 

: state [ $ 2 l ] + ; 
: timetorun [ $ 4 l ] + ; 

: ready? ( task -- ) ] state ] @ ] hot ] and ; 

: interpreter [ $ 0200 l ; 
: task0 [ $ 0300 l ; 
: task1 [ $ 0400 l ; 

$ 0000 task0 state ! 
$ 0000 task1 state ! 

: dispatch ] task0 ] ready? if ] task0 ] running! ; 
      then ] task1 ] ready? if ] task1 ] running! ; 
      then ] interpreter ] running! ; 

: sysclock ] clock ] d@ ] d1+ ] clock ] d! [ $ 35 l ] c@ [ $ 0001 l ] xor [ $ 35 l ] c! 
  ] dispatch ; 

$ 0000 $ 0000 clock d! 
' sysclock 'timer0ovf ! 

: test ] intoff [ $ 35 l ] c@ [ $ 0002 l ] xor [ $ 35 l ] c! ] inton ] test ; 

: on ] inton ; 
on 
