;;; interrupt service routines


int0_isr:
  rcall contextstore
  rcall int0
  rcall fetchexecute
  rjmp contextfetch

int1_isr:
  rcall contextstore
  rcall int1
  rcall fetchexecute
  rjmp contextfetch

timer2comp_isr:
  rcall contextstore
  rcall timer2comp
  rcall fetchexecute
  rjmp contextfetch
  
timer2ovf_isr:
  rcall contextstore
  rcall timer2ovf
  rcall fetchexecute
  rjmp contextfetch
  
timer1capt_isr:
  rcall contextstore
  rcall timer1capt
  rcall fetchexecute
  rjmp contextfetch
  
timer1compa_isr:
  rcall contextstore
  rcall timer1compa
  rcall fetchexecute
  rjmp contextfetch
  
timer1compb_isr:
  rcall contextstore
  rcall timer1compb
  rcall fetchexecute
  rjmp contextfetch
  
timer1ovf_isr:
  rcall contextstore
  rcall timer1ovf
  rcall fetchexecute
  rjmp contextfetch
  
timer0ovf_isr:
  rcall contextstore
  rcall timer0ovf
  rcall fetchexecute
  rjmp contextfetch
  
spistc_isr:
  rcall contextstore
  rcall spistc
  rcall fetchexecute
  rjmp contextfetch
  
usartrxc_isr:
  rcall contextstore
  rcall usartrxc
  rcall fetchexecute
  rjmp contextfetch
  
usartudre_isr:
  rcall contextstore
  rcall usartudre
  rcall fetchexecute
  rjmp contextfetch
  
usarttxc_isr:
  rcall contextstore
  rcall usarttxc
  rcall fetchexecute
  rjmp contextfetch
  
adc_isr:
  rcall contextstore
  rcall adcc
  rcall fetchexecute
  rjmp contextfetch
  
eerdy_isr:
  rcall contextstore
  rcall eerdy
  rcall fetchexecute
  rjmp contextfetch
  
anacomp_isr:
  rcall contextstore
  rcall anacomp
  rcall fetchexecute
  rjmp contextfetch
  
twi_isr:
  rcall contextstore
  rcall twi
  rcall fetchexecute
  rjmp contextfetch
  
spmrdy_isr:
  rcall contextstore
  rcall spmrdy
  rcall fetchexecute
  rjmp contextfetch
  
