;; find
;;
;; ( c-addr addr -- c-addr false | xt true )

.dw link
.set link = pc - 1
.db 'f','i','n','d',0

find:
  ; latest in tosh:tosl
  ;rcall latest
  ;rcall fetch
  ; latest is cell address, lpm uses byte address
  twostar_
  
  ; word in temp1:temp0
  ld temp0,y+
  ld temp1,y+

find_check_word:
  movw z,tos
  ; name field has offset of two
  adiw z,2

  movw x,temp0

find_check_char:
  ; next char of search word
  ld temp2,x+
  ; next char of current word definition
  lpm temp3,z+

  cp temp2,temp3
  brne find_mismatch

find_match:
  ; check for end of word null
  tst temp2
  breq find_found

  ; else get next char and try again
  rjmp find_check_char

find_mismatch:
  ; get address of next word to check
  movw z,tos
  lpm temp2,z+
  lpm temp3,z+
  movw tos,temp2
  twostar_
  ; check for end of list
  adiw tos,0
  brne find_check_word

find_not_found:
  ; put c-addr back
  st -y,temp1
  st -y,temp0
  ; set tos to false
  clr tosl
  clr tosh
  ret

find_found:
  ; get xt of word (1 cell past null byte)
  lsr zh
  ror zl
  ; if z was odd before the shift, then the
  ; string didn't end on a word boundary,
  ; and we need to increment.
  brcc find_dont_increment
  adiw z,1

find_dont_increment:
  st -y,zh
  st -y,zl
  ; set tos to true
  ser tosl
  ser tosh
  ret

