;; word
;;
;; ( char -- c-addr | 0 )

.dw link
.set link = pc - 1
.db 'w','o','r','d',0

word:
  rcall source
  rcall fetch
  rcall toin
  rcall fetch
  ; >in in temp3:temp2
  movw temp2,tos
  drop_
  ; source in temp1:temp0
  movw temp0,tos
  drop_

  movw z,temp0
  add zl,temp2
  adc zh,temp3

  ; skip past opening delimeters
word_find_start:
  ld xl,z+
  cp tosl,xl
  breq word_find_start

  tst xl
  breq word_not_found

  ; save start address in temp3:temp2
  movw temp2,zl
  subi temp2,1

word_find_end:
  ld xl,z+
  cp tosl,xl
  brne word_find_end

  tst xl
  breq word_eol

word_found:
  ; replace delimeter with null
  st -z,zero
  adiw z,1

word_eol:
  movw tos,temp2
  rjmp word_finish

word_not_found:
  movw tos,zero

word_finish:
  ; store new >in
  sub zl,temp0
  sbc zh,temp1
  dup_
  movw tos,zl
  rcall toin
  rcall store
  ret

